/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Text;using System;using System.Collections.Generic;using System.Linq;using SimpleJSON;namespace PluginIdea{    class SpectruamFilterInfo    {        public float low;        public float high;    }    class SendData    {        public float[] samples;    }    public class SystemAudioAction : MVRScript    {        private JSONStorableString floatTriggerActionsStr;        private JSONStorableFloat sampleMultNum;        private JSONStorableFloat rollingMaxSample;        private FloatTrigger SystemRealTimeAudioAmpTrigger;        private JSONStorableStringChooser lipSyncTriggerTypes;        private JSONStorableStringChooser lipSyncResponePresets;        private JSONStorableFloat responseFreqLow;        private JSONStorableFloat responseFreqHigh;        private JSONStorableFloat minLipAmount;        private JSONStorableFloat maxLipAmount;        private JSONStorableFloat updateSpeed;        private List<string> lipSyncTriggerTypesList = new List<string> { "SimpleAudioAmp" };        private List<string> lipResponsePresetsList = new List<string> { "All", "Man", "Girl", "Child" };        private Dictionary<string, SpectruamFilterInfo> dicSpectTruamFilters = new Dictionary<string, SpectruamFilterInfo>();        private float triggerTimer;        private float triggerDur = 0.025f;        private DAZMorph mouthOpen_morph;        private float currentAmp;        private float currentTargetMorphValue;        private float currentMorphValue;        public override void Init()        {            base.Init();            if (containingAtom.type == "SessionPluginManager")            {                SuperController.LogError(Location.GetStr(Location.DontAddOnSessionManager));                return;            }            DataInit();            UIInit();            InitEvent();            MouseOpenMorphyInit();        }        private void DataInit()        {            dicSpectTruamFilters.Add("All", new SpectruamFilterInfo() { low = 0, high = 1 });            dicSpectTruamFilters.Add("Man", new SpectruamFilterInfo() { low = 0f, high = 0.4f });            dicSpectTruamFilters.Add("Girl", new SpectruamFilterInfo() { low = 0f, high = 0.55f });            dicSpectTruamFilters.Add("Child", new SpectruamFilterInfo() { low = 0.3f, high = 0.45f });        }        private void InitEvent()        {            SuperController.singleton.onBeforeSceneSaveHandlers += OnBeforeSceneSave;        }        private void OnBeforeSceneSave()        {            floatTriggerActionsStr.val = SystemRealTimeAudioAmpTrigger.GetJSON().ToString();        }        public override void RestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, JSONArray presetAtoms = null, bool setMissingToDefault = true)        {            base.RestoreFromJSON(jc, restorePhysical, restoreAppearance, presetAtoms, setMissingToDefault);            JSONClass jcRestore = JSONClass.Parse(floatTriggerActionsStr.val).AsObject;            SystemRealTimeAudioAmpTrigger.RestoreFromJSON(jcRestore);        }        private void UIInit()        {                        Utils.OnInitUI(CreateUIElement);            SimpleTriggerHandler.LoadAssets();            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.CommonParaSubtitle), 35, false);            lipSyncResponePresets = Utils.SetupStringChooser(this, Location.GetStr(Location.ResponsePresets), lipResponsePresetsList, 2, false);            lipSyncResponePresets.setCallbackFunction = (val) => {                responseFreqLow.val = dicSpectTruamFilters[val].low;                responseFreqHigh.val = dicSpectTruamFilters[val].high;            };            responseFreqLow = Utils.SetupSliderFloat(this, Location.GetStr(Location.ResponseFreqFilterLow), 0f, 0f, 1f, false);            responseFreqLow.setCallbackFunction = (val) => {                if (val >= responseFreqHigh.val - 0.1f)                {                    responseFreqLow.val = responseFreqHigh.val - 0.1f;                }            };            responseFreqHigh = Utils.SetupSliderFloat(this, Location.GetStr(Location.ResponseFreqFilterHigh), 0.55f, 0f, 1f, false);            responseFreqHigh.setCallbackFunction = (val) => {                if (val <= responseFreqLow.val + 0.1f)                {                    responseFreqHigh.val = responseFreqLow.val + 0.1f;                }            };            Utils.SetupSpacer(this, 50, false);            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.AudioActionSubtitle), 35, false);            floatTriggerActionsStr = Utils.SetupStorableString(this, "SystemAudioSourceInput", "");            SystemRealTimeAudioAmpTrigger = new FloatTrigger(this, "SystemRealTimeAudioAmpTrigger");            Utils.SetupButton(this, Location.GetStr(Location.SetAudioAction), SystemRealTimeAudioAmpTrigger.OpenPanel, false);            sampleMultNum = Utils.SetupSliderFloat(this, Location.GetStr(Location.SampleMultNum), 2.8f, 0.3f, 5f, false);            rollingMaxSample = Utils.SetupSliderFloat(this, Location.GetStr(Location.rollingMaxSample), 1f, 1f, 5f, false);            Utils.SetupSpacer(this, 30, false);            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.LipSyncSubtitle), 35, false);            lipSyncTriggerTypes = Utils.SetupStringChooser(this, Location.GetStr(Location.LipSyncType), lipSyncTriggerTypesList, 0, false);            minLipAmount = Utils.SetupSliderFloat(this, Location.GetStr(Location.MinLipAmount), 0.15f, -0.5f, 2f, false);            maxLipAmount = Utils.SetupSliderFloat(this, Location.GetStr(Location.MaxLipAmount), 1.1f, -0.5f, 2f, false);            updateSpeed = Utils.SetupSliderFloat(this, Location.GetStr(Location.UpdateSpeed), 100, 0, 300, false);            Utils.SetupInfoText(this, Location.GetStr(Location.PluginInfo), 1000, true);        }        private void MouseOpenMorphyInit()        {                        SuperController.singleton.PauseSimulation(3, "Loading " + this.containingAtom.name);            JSONStorable storableByID = this.containingAtom.GetStorableByID("geometry");            if (storableByID != null)            {                DAZCharacterSelector dazcharacterSelector = storableByID as DAZCharacterSelector;                GenerateDAZMorphsControlUI morphsControlUI = dazcharacterSelector.morphsControlUI;                if (morphsControlUI != null)                {                    List<DAZMorph> morphs = morphsControlUI.GetMorphs();                    this.mouthOpen_morph = morphs.FirstOrDefault(x => x.region == "Pose Controls/Head/Mouth" && x.morphName == "PHMMouthOpen");                    if (this.mouthOpen_morph != null)                    {                        this.mouthOpen_morph.SetValue(0);                        this.mouthOpen_morph.isTransient = false;                        this.mouthOpen_morph.isRuntime = false;                    }                    else                    {                        SuperController.LogMessage("mouth open morph not found");                    }                }            }        }        private void Update()        {            triggerTimer += Time.deltaTime;            if (triggerTimer > triggerDur)            {                triggerTimer = 0;                try                {                    if (UDPReceive.Instance.dataReveived != null)                    {                        string sendDataStr = Encoding.Default.GetString(UDPReceive.Instance.dataReveived);                        SendData sendData = JsonUtility.FromJson<SendData>(sendDataStr);                        currentAmp = GetAmp(sendData.samples) * 5;                        currentTargetMorphValue = currentAmp - 0.5f;                        currentTargetMorphValue = Mathf.Clamp(currentTargetMorphValue, minLipAmount.val, maxLipAmount.val);                        SystemRealTimeAudioAmpTrigger.Trigger(currentAmp);                    }                }                catch (System.Exception e)                {                    SuperController.LogError(e.Message);                    return;                }            }            currentMorphValue = Mathf.Lerp(currentMorphValue, currentTargetMorphValue, updateSpeed.val * Time.deltaTime);        }        private float GetAmp(float[] samples)        {            float ampValue = 0f;            int low = (int)(responseFreqLow.val * samples.Length);            int high = (int)(responseFreqHigh.val * samples.Length);            for (int j = low; j < high; j++)            {                samples[j] /= rollingMaxSample.val + 1E-06f;                samples[j] *= sampleMultNum.val;                ampValue += samples[j];            }            ampValue /= (float)(high - low);            return ampValue;        }        private void FixedUpdate()        {            if (this.mouthOpen_morph != null)                this.mouthOpen_morph.SetValue(currentMorphValue);        }        private void OnDestroy()        {            Utils.OnDestroyUI();            UDPReceive.Instance.IsAlive = false;            SuperController.singleton.onBeforeSceneSaveHandlers -= OnBeforeSceneSave;        }    }}